// cpp_methods.cpp: Sample method implementation in C++ to demonstrate
// how methods are often defined (though not always) defined outside
// the 'class' block/construct. Rust has a similar approach with its
// 'impl' blocks.

#include <iostream>

using namespace std;

class MyClass {        // The class
  public:              // Access specifier
    void myMethod();   // Method/function declaration
    void otherMeth();
};

// Method/function definition outside the class
void MyClass::myMethod() {
  cout << "Hello World!";
}

void MyClass::otherMeth() {
  cout << "Adios!";
}
int main() {
  MyClass myObj;     // Create an object of MyClass
  myObj.myMethod();  // Call the method
  myObj.otherMeth();
  return 0;
}
