// Demosntration of method dispatch in Rust
// 
// Adapted from:
// https://doc.rust-lang.org/1.8.0/book/trait-objects.html

trait Foo {
  fn method(&self) -> String;
}
impl Foo for u8 {
  fn method(&self) -> String { format!("u8: {}", *self) }
}

impl Foo for String {
  fn method(&self) -> String { format!("string: {}", *self) }
}

fn do_something<T: Foo>(x: T) {
  x.method();
}

fn main() {
  let x = 5u8;
  let y = "Hello".to_string();

  x.method();
  y.method();

  do_something(x);
  do_something(y);
}
